package cz.kiele.homeautomation.core.dao;

import cz.kiele.homeautomation.core.enums.ActuatorType;
import cz.kiele.homeautomation.core.model.Actuator;
import cz.kiele.homeautomation.core.model.Room;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ActuatorDao extends JpaRepository<Actuator, String>, JpaSpecificationExecutor<Actuator> {

    List<Actuator> findByRoom(Room room);

    Actuator findByRoomAndType(Room room, ActuatorType type);
}
