package cz.kiele.homeautomation.core.dao;

import cz.kiele.homeautomation.core.model.Actuator;
import cz.kiele.homeautomation.core.model.ActuatorState;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface ActuatorStateDao extends JpaRepository<ActuatorState, Long>, JpaSpecificationExecutor<ActuatorState> {

    List<ActuatorState> findByActuator(Actuator actuator);

    ActuatorState findByActuatorAndName(Actuator actuator, String name);

    ActuatorState findByActuatorAndNameAndIsNew(Actuator actuator, String name, boolean isNew);
}
