package cz.kiele.homeautomation.core.dao;

import cz.kiele.homeautomation.core.enums.SensorType;
import cz.kiele.homeautomation.core.model.Room;
import cz.kiele.homeautomation.core.model.Sensor;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface SensorDao extends JpaRepository<Sensor, String>, JpaSpecificationExecutor<Sensor> {

    Sensor findById(String id);

    List<Sensor> findByRoom(Room room);

    List<Sensor> findAllByRoomAndType(Room room, SensorType type);
}
