package cz.kiele.homeautomation.core.model;

import javax.persistence.*;
import javax.validation.constraints.NotNull;


@Entity
@Table(name = "actuator_state")
public class ActuatorState {

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @NotNull
    @Column(name = "actuator_state_id", unique = true)
    private Long id;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "actuator_id", nullable = false)
    private Actuator actuator;

    private String name;

    private String value;

    private boolean isNew = false;

    public ActuatorState() {
    }

    public ActuatorState(String name) {
        this.name = name;
    }

    public ActuatorState(String name, String value) {
        this.name = name;
        this.value = value;
    }

    public ActuatorState(Actuator actuator, String name, String value) {
        this.actuator = actuator;
        this.name = name;
        this.value = value;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Actuator getActuator() {
        return actuator;
    }

    public void setActuator(Actuator actuator) {
        this.actuator = actuator;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public boolean isNew() {
        return isNew;
    }

    public void setNew(boolean aNew) {
        isNew = aNew;
    }
}
