package cz.kiele.homeautomation.core.model;

import cz.kiele.homeautomation.core.enums.Location;

import javax.persistence.*;
import javax.validation.constraints.NotNull;


@MappedSuperclass
public class Component {

    @Id
    @NotNull
    @Column(name = "component_id", unique = true)
    private String id;

    @NotNull
    private String name;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "room_id", nullable = false)
    private Room room;

    @Enumerated(EnumType.STRING)
    private Location location;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Room getRoom() {
        return room;
    }

    public void setRoom(Room room) {
        this.room = room;
    }

    public Location getLocation() {
        return location;
    }

    public void setLocation(Location location) {
        this.location = location;
    }
}
