package cz.kiele.homeautomation.eventmanager.mapper;

import cz.kiele.homeautomation.core.dao.RoomDao;
import cz.kiele.homeautomation.core.dao.SensorDataDao;
import cz.kiele.homeautomation.core.model.Rule;
import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;
import org.apache.commons.jexl3.JexlContext;
import org.apache.commons.jexl3.MapContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class RuleExpressionMapper {

    @Autowired
    RoomDao roomDao;

    @Autowired
    SensorDataDao sensorDataDao;

    public JexlContext createJexlContext(Rule rule){
        JexlContext context = new MapContext();

        mapJexlContextWithExpression(context, rule);

        return context;
    }

    private void mapJexlContextWithExpression(JexlContext context, Rule rule){
            context.set(rule.getSensor().getId(), getLastData(rule.getSensor()).getValue());
    }

    public SensorData getLastData(Sensor sensor){
        SensorData data = sensorDataDao.findFirstBySensorOrderByTimestampDesc(sensor);
        return data;
    }


}
