package cz.kiele.homeautomation.eventmanager.quartz;

import cz.kiele.homeautomation.core.dao.UserDao;
import cz.kiele.homeautomation.core.model.User;
import cz.kiele.homeautomation.securitymodule.checker.IntruderChecker;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;
import org.springframework.stereotype.Component;

import java.util.List;

@Component("intruderDetectorJob")
public class IntruderDetectorJob extends QuartzJobBean {

    @Autowired
    IntruderChecker intruderChecker;

    @Autowired
    UserDao userDao;

    @Override
    protected void executeInternal(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        if (intruderChecker.isIntruderDetected()){
            List<User> users = userDao.findAll();
            for (User user : users) {
                intruderChecker.sendIntruderDetectedNotification(user.getEmail());
            }
        }

    }
}
