package cz.kiele.homeautomation.restapi.controller;

import cz.kiele.homeautomation.core.enums.Role;
import cz.kiele.homeautomation.restapi.model.UserJsonCrate;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.core.userdetails.User;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Iterator;
import java.util.Set;

@RestController
public class AuthenticateController {

    @RequestMapping(value = "/authenticate", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
    public ResponseEntity<UserJsonCrate> authenticate()
    {
        User user = (User) SecurityContextHolder.getContext().getAuthentication().getPrincipal();
        Set<GrantedAuthority> authorities = (Set<GrantedAuthority>) user.getAuthorities();
        Role role = null;
        for (Iterator<GrantedAuthority> it = authorities.iterator(); it.hasNext(); ) {
            GrantedAuthority authority = it.next();
            role = Role.valueOf(authority.toString());
        }
        UserJsonCrate userJson = new UserJsonCrate(user.getUsername(), role);
        return new ResponseEntity<UserJsonCrate>(userJson, HttpStatus.OK);
    }
}
