package cz.kiele.homeautomation.restapi.service;

import cz.kiele.homeautomation.core.dao.UserDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Collection;

@Service("userDetailsService")
public class UserDetailsServiceImpl implements UserDetailsService {

	@Autowired
	private UserDao userDao;

	@Override
	public UserDetails loadUserByUsername(String login) throws UsernameNotFoundException {
		cz.kiele.homeautomation.core.model.User user = userDao.findByEmail(login);
		if (user == null)
			throw new UsernameNotFoundException("user not found");

		return buildUserFromUserEntity(user);
	}

	@Transactional(readOnly = true)
	private User buildUserFromUserEntity(cz.kiele.homeautomation.core.model.User  user) {

		String username = user.getEmail();
		String password = user.getPassword();

		// boolean enabled = true;
		// boolean accountNonExpired = true;
		// boolean credentialsNonExpired = true;
		// boolean accountNonLocked = true;

		Collection<GrantedAuthority> authorities = new ArrayList<GrantedAuthority>();
		authorities.add(new SimpleGrantedAuthority(user.getRole().toString()));

		User finalUser = new User(username, password, authorities);
		return finalUser;
	}

}
