package cz.kiele.homeautomation.securitymodule.checker;

import cz.kiele.homeautomation.securitymodule.notifier.EmailNotifier;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class IntruderChecker {

    public static final String INTRUDER_DETECTED_SUBJECT = "Intruder detected!";

    public static final String INTRUDER_DETECTED_MESSAGE = "Intruder was detected in your property! Please Check it.";

    @Autowired
    MovementChecker movementChecker;

    @Autowired
    UserPresenceChecker userPresenceChecker;

    @Autowired
    EmailNotifier emailNotifier;

    public boolean isIntruderDetected(){
        if (movementChecker.isMovementDetectedInHome() && !userPresenceChecker.isAnybodyHome()){
            return true;
        }
        return false;
    }

    public void sendIntruderDetectedNotification(String to){
        emailNotifier.sendMail(emailNotifier.getSender(), to, INTRUDER_DETECTED_SUBJECT, INTRUDER_DETECTED_MESSAGE);
    }

}
