package cz.kiele.homeautomation.securitymodule.checker;

import cz.kiele.homeautomation.core.dao.RoomDao;
import cz.kiele.homeautomation.core.dao.SensorDao;
import cz.kiele.homeautomation.core.dao.SensorDataDao;
import cz.kiele.homeautomation.core.enums.SensorType;
import cz.kiele.homeautomation.core.model.Room;
import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class MovementChecker {

    @Autowired
    SensorDataDao sensorDataDao;

    @Autowired
    SensorDao sensorDao;

    @Autowired
    RoomDao roomDao;

    public boolean isMovementDetectedInHome(){
        List<Room> rooms = roomDao.findAll();
        for(Room room : rooms){
            if(isMovementDetectedInRoom(room)){
                return true;
            }
        }
        return false;
    }

    public boolean isMovementDetectedInRoom(Room room){
        List<Sensor> sensors = sensorDao.findAllByRoomAndType(room, SensorType.MOTION);
        for(Sensor sen : sensors) {
            SensorData motionData = sensorDataDao.findFirstBySensorOrderByTimestampDesc(sen);
            if(motionData.getValue() == 1f){
                return true;
            }
        }
        return false;
    }
}
