package cz.kiele.homeautomation.transcom.actuators.lifx.adapter;

import cz.kiele.homeautomation.core.model.Actuator;
import cz.kiele.homeautomation.core.adapters.LightControlAdapter;
import cz.kiele.homeautomation.transcom.actuators.lifx.communicator.LifxRestApiCommunicator;
import cz.kiele.homeautomation.transcom.actuators.lifx.model.Bulb;
import cz.kiele.homeautomation.transcom.actuators.mappings.LifxBulbActuatorMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class LifxBulbAdapter implements LightControlAdapter{

    @Autowired
    LifxBulbActuatorMapper lifxMapper;

    @Autowired
    LifxRestApiCommunicator communicator;

    @Override
    public void turnLightOn(Actuator actuator) {
        Bulb bulb = lifxMapper.createBulbFromActuator(actuator);
        bulb.setPower(Bulb.POWER_ON);
        communicator.setLifxBulbState(bulb);
    }

    @Override
    public void turnLightOff(Actuator actuator) {
        Bulb bulb = lifxMapper.createBulbFromActuator(actuator);
        bulb.setPower(Bulb.POWER_OFF);
        communicator.setLifxBulbState(bulb);
    }

    @Override
    public void setBrightness(Actuator actuator, double brightness) {
        Bulb bulb = lifxMapper.createBulbFromActuator(actuator);
        bulb.setBrightness(brightness);
        communicator.setLifxBulbState(bulb);
    }
}
