package cz.kiele.homeautomation.transcom.controllers;

import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;
import cz.kiele.homeautomation.transcom.sensors.collectors.LightIntensityDataCollector;
import cz.kiele.homeautomation.transcom.sensors.mappings.LightIntensitySensorMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
public class LightIntensityDataController {

    Logger logger = LoggerFactory.getLogger(LightIntensityDataController.class);

    @Autowired
    LightIntensitySensorMapper intensityMapper;

    @RequestMapping(value = "/lightIntensityCollect", method = RequestMethod.POST, headers = {"Content-type=application/json"})
    public @ResponseBody
    void collectLightIntensityData(@RequestBody LightIntensityDataCollector lightIntensityDataCollector){
        logger.info(String.format("Receiving data from light sensor with id: %s", lightIntensityDataCollector.getSensorId()) );

        Sensor sensor = (Sensor) intensityMapper.mapSensorToModel(lightIntensityDataCollector.getSensorId());
        SensorData sensorData = intensityMapper.createSensorData(sensor, lightIntensityDataCollector.getLightIntensity());
        intensityMapper.storeSensorValues(sensorData);

        logger.info(String.format("Data from sensor %s stored!", lightIntensityDataCollector.getSensorId()) );
    }

}
