package cz.kiele.homeautomation.transcom.controllers;

import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;
import cz.kiele.homeautomation.transcom.sensors.collectors.MovementSensorDataCollector;
import cz.kiele.homeautomation.transcom.sensors.mappings.MovementSensorMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;


@RestController
public class MovementSensorDataController {

    Logger logger = LoggerFactory.getLogger(MovementSensorDataController.class);

    @Autowired
    private MovementSensorMapper movementMapper;


    @RequestMapping(value = "/movementSensorDataCollect", method = RequestMethod.POST, headers = {"Content-type=application/json"}, consumes = MediaType.APPLICATION_JSON_VALUE)
    public @ResponseBody
    void detectMovement(@RequestBody MovementSensorDataCollector movementData){
        logger.info(String.format("Receiving data from movement sensor with id: %s", movementData.getSensorId()) );

        Sensor sensor = (Sensor) movementMapper.mapSensorToModel(movementData.getSensorId());
        SensorData sensorData = null;
        if (movementMapper.isMovementDetected(movementData.getMovementData())) {
            sensorData = movementMapper.createSensorData(sensor, MovementSensorMapper.MOVEMENT_DETECTED_TRUE);
        } else {
            sensorData = movementMapper.createSensorData(sensor, MovementSensorMapper.MOVEMENT_DETECTED_FALSE);
        }
        movementMapper.storeSensorValues(sensorData);

        logger.info(String.format("Data from sensor %s stored!", movementData.getSensorId()) );
    }
}
