package cz.kiele.homeautomation.transcom.controllers;

import cz.kiele.homeautomation.core.dao.DeviceDao;
import cz.kiele.homeautomation.core.enums.DeviceState;
import cz.kiele.homeautomation.core.model.Device;
import cz.kiele.homeautomation.transcom.actuators.lifx.communicator.LifxRestApiCommunicator;
import cz.kiele.homeautomation.transcom.sensors.collectors.RouterNmapDataCollector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;


@RestController
public class RouterNmapDataController {

    Logger logger = LoggerFactory.getLogger(RouterNmapDataController.class);

    @Autowired
    LifxRestApiCommunicator communicator;

    @Autowired
    DeviceDao deviceDao;


    @RequestMapping(value = "/nmapDataCollect", method = RequestMethod.POST, headers = {"Content-type=application/json"}, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    public ResponseEntity<RouterNmapDataCollector> collectNmapData(@RequestBody RouterNmapDataCollector nmapData){
        logger.info(String.format("Checking for known devices in network.") );
        List<Device> devices = deviceDao.findAll();
        for (Device dev : devices){
            if (nmapData.getNmapOutput().toLowerCase().contains(dev.getMacAddress().toLowerCase())){
                dev.setState(DeviceState.ONLINE);
                deviceDao.save(dev);
            } else {
                dev.setState(DeviceState.OFFLINE);
                deviceDao.save(dev);
            }
        }
        return new ResponseEntity<RouterNmapDataCollector>(nmapData, HttpStatus.OK);

    }
}
