package cz.kiele.homeautomation.transcom.sensors.mappings;

import cz.kiele.homeautomation.core.enums.Unit;
import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;
import cz.kiele.homeautomation.transcom.processors.MovementDataProcessor;
import org.springframework.beans.factory.annotation.Autowired;

@org.springframework.stereotype.Component
public class MovementSensorMapper extends AbstractSensorMapper  {

    public final static float MOVEMENT_DETECTED_TRUE = 1f;

    public final static float MOVEMENT_DETECTED_FALSE = 0f;

    @Autowired
    private MovementDataProcessor dataProcessor;

    @Override
    public SensorData createSensorData(Sensor sensor, float data) {
        return new SensorData(sensor, data, Unit.MOVEMENT);
    }

    public boolean isMovementDetected(int[] data){
        return dataProcessor.movementDetected(data);
    }

}
