package cz.kiele.homeautomation.transcom.sensors.mappings;

import cz.kiele.homeautomation.core.enums.Unit;
import cz.kiele.homeautomation.core.model.Sensor;
import cz.kiele.homeautomation.core.model.SensorData;

@org.springframework.stereotype.Component
public class SensorCoreModelMapper extends AbstractSensorMapper {

    public static final String TEMPERATURE = "Temperature";

    public static final String HUMIDITY = "Humidity";

    @Override
    public SensorData createSensorData(Sensor sensor, float data) {
        return new SensorData(sensor, data);
    }

    public SensorData createSensorData(Sensor sensor, float data, String description){
        SensorData sensorData = createSensorData(sensor, data);
        if (description.equals(TEMPERATURE)){
            sensorData.setUnit(Unit.CELSIUS);
        } else if (description.equals(HUMIDITY)){
            sensorData.setUnit(Unit.HUMIDITY);
        }

        return sensorData;
    }
}
