--
-- PostgreSQL database dump
--

-- Dumped from database version 9.6.3
-- Dumped by pg_dump version 9.6.3

-- Started on 2017-09-04 05:13:46

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

CREATE SCHEMA IF NOT EXISTS homeautomation;

--
-- TOC entry 1 (class 3079 OID 12387)
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: -
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- TOC entry 2199 (class 0 OID 0)
-- Dependencies: 1
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: -
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


SET search_path = public, pg_catalog;

SET default_with_oids = false;

--
-- TOC entry 185 (class 1259 OID 40095)
-- Name: actuator; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE actuator (
    actuator_id character varying(255) NOT NULL,
    location character varying(255),
    name character varying(255) NOT NULL,
    type character varying(255),
    room_id integer NOT NULL
);


--
-- TOC entry 186 (class 1259 OID 40103)
-- Name: actuator_state; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE actuator_state (
    actuator_state_id bigint NOT NULL,
    is_new boolean NOT NULL,
    name character varying(255),
    value character varying(255),
    actuator_id character varying(255) NOT NULL
);


--
-- TOC entry 187 (class 1259 OID 40111)
-- Name: device; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE device (
    device_id integer NOT NULL,
    mac_address character varying(255) NOT NULL,
    name character varying(255) NOT NULL,
    state character varying(255),
    type character varying(255),
    user_id integer NOT NULL
);


--
-- TOC entry 188 (class 1259 OID 40119)
-- Name: event; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE event (
    event_id bigint NOT NULL,
    command character varying(255) NOT NULL,
    command_parameter character varying(255),
    created timestamp without time zone NOT NULL,
    actuator_id character varying(255) NOT NULL
);


--
-- TOC entry 195 (class 1259 OID 40219)
-- Name: hibernate_sequence; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE hibernate_sequence
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 189 (class 1259 OID 40127)
-- Name: room; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE room (
    room_id integer NOT NULL,
    name character varying(255) NOT NULL,
    type character varying(255)
);


--
-- TOC entry 190 (class 1259 OID 40132)
-- Name: rule; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE rule (
    rule_id bigint NOT NULL,
    command character varying(255) NOT NULL,
    command_parameter character varying(255),
    expression character varying(255) NOT NULL,
    name character varying(255) NOT NULL,
    actuator_id character varying(255) NOT NULL,
    room_id integer NOT NULL,
    sensor_id character varying(255) NOT NULL
);


--
-- TOC entry 191 (class 1259 OID 40140)
-- Name: sensor; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE sensor (
    sensor_id character varying(255) NOT NULL,
    location character varying(255),
    name character varying(255) NOT NULL,
    type character varying(255),
    room_id integer NOT NULL
);


--
-- TOC entry 192 (class 1259 OID 40148)
-- Name: sensor_data; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE sensor_data (
    sensor_data_id bigint NOT NULL,
    "timestamp" timestamp without time zone NOT NULL,
    unit character varying(255),
    value real NOT NULL,
    sensor_id character varying(255) NOT NULL
);


--
-- TOC entry 193 (class 1259 OID 40156)
-- Name: settings; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE settings (
    setting_id bigint NOT NULL,
    room_id integer NOT NULL
);


--
-- TOC entry 194 (class 1259 OID 40161)
-- Name: users; Type: TABLE; Schema: public; Owner: -
--

CREATE TABLE users (
    user_id integer NOT NULL,
    email character varying(255) NOT NULL,
    name character varying(255) NOT NULL,
    nickname character varying(255),
    password character varying(255) NOT NULL,
    role character varying(255),
    surname character varying(255) NOT NULL
);


--
-- TOC entry 2047 (class 2606 OID 40102)
-- Name: actuator actuator_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY actuator
    ADD CONSTRAINT actuator_pkey PRIMARY KEY (actuator_id);


--
-- TOC entry 2049 (class 2606 OID 40110)
-- Name: actuator_state actuator_state_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY actuator_state
    ADD CONSTRAINT actuator_state_pkey PRIMARY KEY (actuator_state_id);


--
-- TOC entry 2051 (class 2606 OID 40118)
-- Name: device device_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY device
    ADD CONSTRAINT device_pkey PRIMARY KEY (device_id);


--
-- TOC entry 2053 (class 2606 OID 40126)
-- Name: event event_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY event
    ADD CONSTRAINT event_pkey PRIMARY KEY (event_id);


--
-- TOC entry 2055 (class 2606 OID 40131)
-- Name: room room_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY room
    ADD CONSTRAINT room_pkey PRIMARY KEY (room_id);


--
-- TOC entry 2057 (class 2606 OID 40139)
-- Name: rule rule_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rule
    ADD CONSTRAINT rule_pkey PRIMARY KEY (rule_id);


--
-- TOC entry 2061 (class 2606 OID 40155)
-- Name: sensor_data sensor_data_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sensor_data
    ADD CONSTRAINT sensor_data_pkey PRIMARY KEY (sensor_data_id);


--
-- TOC entry 2059 (class 2606 OID 40147)
-- Name: sensor sensor_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sensor
    ADD CONSTRAINT sensor_pkey PRIMARY KEY (sensor_id);


--
-- TOC entry 2063 (class 2606 OID 40160)
-- Name: settings settings_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY settings
    ADD CONSTRAINT settings_pkey PRIMARY KEY (setting_id);


--
-- TOC entry 2065 (class 2606 OID 40168)
-- Name: users users_pkey; Type: CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY users
    ADD CONSTRAINT users_pkey PRIMARY KEY (user_id);


--
-- TOC entry 2074 (class 2606 OID 40209)
-- Name: sensor_data fk_39jx2r6640y3tsybggysncjxm; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sensor_data
    ADD CONSTRAINT fk_39jx2r6640y3tsybggysncjxm FOREIGN KEY (sensor_id) REFERENCES sensor(sensor_id);


--
-- TOC entry 2075 (class 2606 OID 40214)
-- Name: settings fk_cykfj0tcseuefna6lxihrrhhn; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY settings
    ADD CONSTRAINT fk_cykfj0tcseuefna6lxihrrhhn FOREIGN KEY (room_id) REFERENCES room(room_id);


--
-- TOC entry 2070 (class 2606 OID 40189)
-- Name: rule fk_emn6haggfa433cwv4eobkyalk; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rule
    ADD CONSTRAINT fk_emn6haggfa433cwv4eobkyalk FOREIGN KEY (actuator_id) REFERENCES actuator(actuator_id);


--
-- TOC entry 2067 (class 2606 OID 40174)
-- Name: actuator_state fk_gpv0jc8m14if0mo9ma28a37eh; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY actuator_state
    ADD CONSTRAINT fk_gpv0jc8m14if0mo9ma28a37eh FOREIGN KEY (actuator_id) REFERENCES actuator(actuator_id);


--
-- TOC entry 2066 (class 2606 OID 40169)
-- Name: actuator fk_jqn8y4wxjxvmu10urnrtwfy6b; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY actuator
    ADD CONSTRAINT fk_jqn8y4wxjxvmu10urnrtwfy6b FOREIGN KEY (room_id) REFERENCES room(room_id);


--
-- TOC entry 2069 (class 2606 OID 40184)
-- Name: event fk_nxapbf863o6pg4wv4p17fvcot; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY event
    ADD CONSTRAINT fk_nxapbf863o6pg4wv4p17fvcot FOREIGN KEY (actuator_id) REFERENCES actuator(actuator_id);


--
-- TOC entry 2073 (class 2606 OID 40204)
-- Name: sensor fk_oq9hnll0xs2nj0d1d3x0xj99c; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sensor
    ADD CONSTRAINT fk_oq9hnll0xs2nj0d1d3x0xj99c FOREIGN KEY (room_id) REFERENCES room(room_id);


--
-- TOC entry 2072 (class 2606 OID 40199)
-- Name: rule fk_q1moumxb4j535q86stgrsgbsj; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rule
    ADD CONSTRAINT fk_q1moumxb4j535q86stgrsgbsj FOREIGN KEY (sensor_id) REFERENCES sensor(sensor_id);


--
-- TOC entry 2071 (class 2606 OID 40194)
-- Name: rule fk_rg449fqai5rws9mula3d4hvm8; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY rule
    ADD CONSTRAINT fk_rg449fqai5rws9mula3d4hvm8 FOREIGN KEY (room_id) REFERENCES room(room_id);


--
-- TOC entry 2068 (class 2606 OID 40179)
-- Name: device fk_s9ldpb0w8p735xk2hkbgrhdol; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY device
    ADD CONSTRAINT fk_s9ldpb0w8p735xk2hkbgrhdol FOREIGN KEY (user_id) REFERENCES users(user_id);


-- Completed on 2017-09-04 05:13:50

--
-- PostgreSQL database dump complete
--

