package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.SetupDTO;
import cz.kiele.homeautomation.webgui.enums.ActuatorType;
import cz.kiele.homeautomation.webgui.enums.Location;
import cz.kiele.homeautomation.webgui.model.Actuator;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Controller
public class ActuatorController extends AbstractController{

    public static final String PATH_ADD_ACTUATOR = "/addActuator";

    public static final String PATH_GET_SETUP = "/getSetup";

    @RequestMapping("/pages/addActuator")
    public ModelAndView addActuatorPage(){
        ModelAndView model = new ModelAndView();
        List<ActuatorType> types = new ArrayList<ActuatorType>( Arrays.asList(ActuatorType.values() ));
        List<Location> locations = new ArrayList<Location>( Arrays.asList(Location.values() ));

        HttpEntity<SetupDTO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<SetupDTO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_GET_SETUP, HttpMethod.GET, entity, SetupDTO.class);
        SetupDTO setupDTO = response.getBody();

        model.addObject("actuator", new Actuator());
        model.addObject("types", types);
        model.addObject("locations", locations);
        model.addObject("rooms", setupDTO.getRooms());

        model.setViewName("/admin/addActuator");
        return model;
    }

    @RequestMapping(value = "/addActuator", method = RequestMethod.POST)
    public String addActuator(@ModelAttribute("Actuator")Actuator actuator, BindingResult result, ModelMap model){

        HttpEntity<Actuator> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Actuator> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ADD_ACTUATOR, HttpMethod.POST, entity, Actuator.class);

        return "redirect:/pages/setup/";
    }

}
