package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.SetupDTO;
import cz.kiele.homeautomation.webgui.enums.DeviceState;
import cz.kiele.homeautomation.webgui.enums.DeviceType;
import cz.kiele.homeautomation.webgui.model.Device;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Controller
public class DeviceController extends AbstractController{

    public static final String PATH_ADD_DEVICE = "/addDevice";

    public static final String PATH_GET_SETUP = "/getSetup";


    @RequestMapping("/pages/addDevice")
    public ModelAndView addDevicePage(){
        ModelAndView model = new ModelAndView();
        List<DeviceType> types = new ArrayList<DeviceType>( Arrays.asList(DeviceType.values() ));
        List<DeviceState> states = new ArrayList<DeviceState>( Arrays.asList(DeviceState.values() ));

        HttpEntity<SetupDTO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<SetupDTO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_GET_SETUP, HttpMethod.GET, entity, SetupDTO.class);
        SetupDTO setupDTO = response.getBody();

        model.addObject("device", new Device());
        model.addObject("types", types);
        model.addObject("states", states);
        model.addObject("users", setupDTO.getUsers());

        model.setViewName("/admin/addDevice");
        return model;
    }

    @RequestMapping(value = "/addDevice", method = RequestMethod.POST)
    public String addDevice(@ModelAttribute("Device")Device device, BindingResult result, ModelMap model){

        HttpEntity<Device> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Device> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ADD_DEVICE, HttpMethod.POST, entity, Device.class);

        return "redirect:/pages/setup/";
    }

}
