package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.AllRoomsDO;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;


@Controller
public class MainController extends AbstractController{

    public static final String PATH_MAIN = "/main";


    @RequestMapping("/pages/main")
    public ModelAndView  index(){
        ModelAndView model = new ModelAndView();

        HttpEntity<AllRoomsDO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<AllRoomsDO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_MAIN, HttpMethod.GET, entity, AllRoomsDO.class);
        AllRoomsDO allRoomsInfo = response.getBody();

        model.addObject("rooms", allRoomsInfo.getAllRoomsInfo());

        model.setViewName("index");
        return model;
    }

}
