package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.SetupDTO;
import cz.kiele.homeautomation.webgui.model.Rule;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class RuleController extends AbstractController{

    public static final String PATH_ADD_RULE = "/addRule";

    public static final String PATH_GET_SETUP = "/getSetup";

    @RequestMapping("/pages/addRule")
    public ModelAndView addRulePage(){
        ModelAndView model = new ModelAndView();

        HttpEntity<SetupDTO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<SetupDTO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_GET_SETUP, HttpMethod.GET, entity, SetupDTO.class);
        SetupDTO setupDTO = response.getBody();

        model.addObject("rule", new Rule());
        model.addObject("rooms", setupDTO.getRooms());
        model.addObject("sensors", setupDTO.getSensors());
        model.addObject("actuators", setupDTO.getActuators());

        model.setViewName("/admin/addRule");
        return model;
    }

    @RequestMapping(value = "/addRule", method = RequestMethod.POST)
    public String addRule(@ModelAttribute("Rule")Rule rule, BindingResult result, ModelMap model){

        HttpEntity<Rule> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Rule> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ADD_RULE, HttpMethod.POST, entity, Rule.class);

        return "redirect:/pages/setup/";
    }

}
