package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.SetupDTO;
import cz.kiele.homeautomation.webgui.enums.Location;
import cz.kiele.homeautomation.webgui.enums.SensorType;
import cz.kiele.homeautomation.webgui.model.Sensor;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Controller
public class SensorController extends AbstractController{

    public static final String PATH_ADD_SENSOR = "/addSensor";

    public static final String PATH_GET_SETUP = "/getSetup";


    @RequestMapping("/pages/addSensor")
    public ModelAndView addSensorPage(){
        ModelAndView model = new ModelAndView();
        List<SensorType> types = new ArrayList<SensorType>( Arrays.asList(SensorType.values() ));
        List<Location> locations = new ArrayList<Location>( Arrays.asList(Location.values() ));

        HttpEntity<SetupDTO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<SetupDTO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_GET_SETUP, HttpMethod.GET, entity, SetupDTO.class);
        SetupDTO setupDTO = response.getBody();

        model.addObject("sensor", new Sensor());
        model.addObject("types", types);
        model.addObject("locations", locations);
        model.addObject("rooms", setupDTO.getRooms());

        model.setViewName("/admin/addSensor");
        return model;
    }

    @RequestMapping(value = "/addSensor", method = RequestMethod.POST)
    public String addSensor(@ModelAttribute("Sensor")Sensor sensor, BindingResult result, ModelMap model){

        HttpEntity<Sensor> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Sensor> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ADD_SENSOR, HttpMethod.POST, entity, Sensor.class);

        return "redirect:/pages/setup/";
    }

}
