package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.data_objects.SetupDTO;
import cz.kiele.homeautomation.webgui.model.*;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class SetupController extends AbstractController{

    public static final String PATH_GET_SETUP = "/getSetup";

    public static final String PATH_ROOM_DELETE = "/room/delete/";

    public static final String PATH_USER_DELETE = "/user/delete/";

    public static final String PATH_DEVICE_DELETE = "/device/delete/";

    public static final String PATH_RULE_DELETE = "/rule/delete/";

    public static final String PATH_SENSOR_DELETE = "/sensor/delete/";

    public static final String PATH_ACTUATOR_DELETE = "/actuator/delete/";

    @RequestMapping("/pages/setup")
    public ModelAndView setupPage(){
        ModelAndView model = new ModelAndView();

        HttpEntity<SetupDTO> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<SetupDTO> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_GET_SETUP, HttpMethod.GET, entity, SetupDTO.class);
        SetupDTO setupDTO = response.getBody();

        model.addObject("setup", setupDTO);

        model.setViewName("/admin/setup");
        return model;
    }

    @RequestMapping("/delete/room/{id}")
    public String roomDelete(@PathVariable("id") int id){
        HttpEntity<Room> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Room> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ROOM_DELETE + id, HttpMethod.GET, entity, Room.class);

        return "redirect:/pages/setup/";
    }

    @RequestMapping("/delete/user/{id}")
    public String userDelete(@PathVariable("id") int id){
        HttpEntity<User> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<User> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_USER_DELETE + id, HttpMethod.GET, entity, User.class);

        return "redirect:/pages/setup/";
    }

    @RequestMapping("/delete/device/{id}")
    public String deviceDelete(@PathVariable("id") int id){
        HttpEntity<Device> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Device> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_DEVICE_DELETE + id, HttpMethod.GET, entity, Device.class);

        return "redirect:/pages/setup/";
    }

    @RequestMapping("/delete/rule/{id}")
    public String ruleDelete(@PathVariable("id") long id){
        HttpEntity<Rule> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Rule> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_RULE_DELETE + id, HttpMethod.GET, entity, Rule.class);

        return "redirect:/pages/setup/";
    }

    @RequestMapping("/delete/sensor/{id}")
    public String sensorDelete(@PathVariable("id") String id){
        HttpEntity<Sensor> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Sensor> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_SENSOR_DELETE + id, HttpMethod.GET, entity, Sensor.class);

        return "redirect:/pages/setup/";
    }

    @RequestMapping("/delete/actuator/{id}")
    public String actuatorDelete(@PathVariable("id") String id){
        HttpEntity<Actuator> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<Actuator> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ACTUATOR_DELETE + id, HttpMethod.GET, entity, Actuator.class);

        return "redirect:/pages/setup/";
    }

}
