package cz.kiele.homeautomation.webgui.controller;

import cz.kiele.homeautomation.webgui.enums.Role;
import cz.kiele.homeautomation.webgui.model.User;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.servlet.ModelAndView;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Controller
public class UserController extends AbstractController{

    public static final String PATH_ADD_USER = "/addUser";

    @RequestMapping("/pages/addUser")
    public ModelAndView addUserPage(){
        ModelAndView model = new ModelAndView();
        List<Role> roles = new ArrayList<Role>( Arrays.asList(Role.values() ));

        model.addObject("user", new User());
        model.addObject("roles", roles);

        model.setViewName("/admin/addUser");
        return model;
    }

    @RequestMapping(value = "/addUser", method = RequestMethod.POST)
    public String addUser(@ModelAttribute("User")User user, BindingResult result, ModelMap model){

        HttpEntity<User> entity = new HttpEntity<>(basicAuthHeaders());
        RestTemplate restTemplate = templateFactory.getObject();
        ResponseEntity<User> response = restTemplate.exchange(templateFactory.getTargetUri() + PATH_ADD_USER, HttpMethod.POST, entity, User.class);

        return "redirect:/pages/setup/";
    }

}
