package cz.kiele.homeautomation.webgui.model;

import java.time.LocalDateTime;

public class Event {

    private long id;

    private String command;

    private String commandParameter;

    private Actuator actuator;

    private LocalDateTime created;

    public Event() {
        this.created = LocalDateTime.now();
    }


    public Event(String command) {
        this.command = command;
        this.created = LocalDateTime.now();
    }

    public Event(String command, String commandParameter) {
        this.command = command;
        this.commandParameter = commandParameter;
        this.created = LocalDateTime.now();
    }

    public Event(String command, Actuator actuator) {
        this.command = command;
        this.actuator = actuator;
        this.created = LocalDateTime.now();
    }

    public Event(String command, String commandParameter, Actuator actuator) {
        this.command = command;
        this.commandParameter = commandParameter;
        this.actuator = actuator;
        this.created = LocalDateTime.now();
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public String getCommand() {
        return command;
    }

    public void setCommand(String command) {
        this.command = command;
    }

    public String getCommandParameter() {
        return commandParameter;
    }

    public void setCommandParameter(String commandParameter) {
        this.commandParameter = commandParameter;
    }

    public Actuator getActuator() {
        return actuator;
    }

    public void setActuator(Actuator actuator) {
        this.actuator = actuator;
    }

    public LocalDateTime getCreated() {
        return created;
    }

    public void setCreated(LocalDateTime created) {
        this.created = created;
    }

}
