package cz.kiele.homeautomation.webgui.rest;

import cz.kiele.homeautomation.webgui.security.HttpComponentsClientHttpRequestFactoryBasicAuth;
import org.apache.http.HttpHost;
import org.springframework.beans.factory.FactoryBean;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

@Component
public class RestTemplateFactory
        implements FactoryBean<RestTemplate>, InitializingBean {

    private String host = "localhost";

    private int port = 8080;

    private String schema = "http";

    private String applicationRootName = "HomeAutomation_rest_api";

    private RestTemplate restTemplate;

    public RestTemplate getObject() {
        return restTemplate;
    }
    public Class<RestTemplate> getObjectType() {
        return RestTemplate.class;
    }
    public boolean isSingleton() {
        return true;
    }

    public void afterPropertiesSet() {
        HttpHost host = new HttpHost(this.host, this.port, this.schema);
        restTemplate = new RestTemplate(
                new HttpComponentsClientHttpRequestFactoryBasicAuth(host));
    }

    public String getTargetUri(){
        return schema + "://" + host + ":" + port + "/" + applicationRootName;
    }


    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public int getPort() {
        return port;
    }

    public void setPort(int port) {
        this.port = port;
    }

    public String getSchema() {
        return schema;
    }

    public void setSchema(String schema) {
        this.schema = schema;
    }

    public String getApplicationRootName() {
        return applicationRootName;
    }

    public void setApplicationRootName(String applicationRootName) {
        this.applicationRootName = applicationRootName;
    }
}
