package cz.kiele.homeautomation.webgui.security;


import cz.kiele.homeautomation.webgui.model.UserJsonCrate;
import cz.kiele.homeautomation.webgui.rest.RestTemplateFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.*;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.nio.charset.Charset;
import java.util.Base64;

@Component
public class AuthenticationApi {

    public static final String AUTHENTICATE = "/authenticate";

    @Autowired
    private RestTemplateFactory templateFactory;

    public ResponseEntity<UserJsonCrate> authenticate(String username, String pass) {
        HttpEntity<UserJsonCrate> entity = new HttpEntity<>(createHeaders(username, pass));
        RestTemplate restTemplate = templateFactory.getObject();
        return restTemplate.exchange(templateFactory.getTargetUri() + AUTHENTICATE, HttpMethod.GET, entity, UserJsonCrate.class);
    }

    private HttpHeaders createHeaders(String email, String password) {
                HttpHeaders acceptHeaders = new HttpHeaders() {
            {
                set(HttpHeaders.ACCEPT,
                        MediaType.APPLICATION_JSON.toString());
            }
        };
        String authorization = email + ":" + password;
        String basic = new String(Base64.getEncoder().encode
                (authorization.getBytes(Charset.forName("US-ASCII"))));
        acceptHeaders.set("Authorization", "Basic " + basic);

        return acceptHeaders;
    }
}
