<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ include file="/WEB-INF/pages/parts/taglibs.jsp"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <%@ include file="/WEB-INF/pages/parts/styles.jsp"%>
    <spring:url value="/resources/styles/style.css" var="css_url" />

    <title>HomeAutomationWeb</title>
</head>
<body>
<div>
    <c:set var="contextPath" value="${pageContext.request.contextPath}"/>
    <%@ include file="/WEB-INF/pages/parts/header.jsp"%>
    <div class="container">
        <div class="row">
            <div id="main_content" class="col-md-12 col-centered">
                <div class="row text-center">
                    <h1>Přidej pravidlo</h1>

                    <form:form method="POST" modelAttribute="rule" action="${contextPath}/addRule">
                        <table class="table table-striped">
                            <tr>
                                <td>Název:</td>
                                <td><form:input path="name" /></td>
                                <td><form:errors path="name" cssClass="error" /></td>
                            </tr>
                            <tr>
                                <td>Výraz:</td>
                                <td><form:input path="expression" /></td>
                                <td><form:errors path="expression" cssClass="error" /></td>
                            </tr>
                            <tr>
                                <td>Příkaz:</td>
                                <td><form:input path="command" /></td>
                                <td><form:errors path="command" cssClass="error" /></td>
                            </tr>
                            <tr>
                                <td>Parametr:</td>
                                <td><form:input path="commandParameter" /></td>
                                <td><form:errors path="commandParameter" cssClass="error" /></td>
                            </tr>
                            <tr>
                                <td>Sensor:</td>
                                <td>
                                    <form:select path="sensor">
                                        <form:option value="" label="*** Select Option ***" />
                                        <form:options items="${sensors}" itemValue="id" itemLabel="name" />
                                    </form:select>
                                </td>
                            </tr>
                            <tr>
                                <td>Aktuátor:</td>
                                <td>
                                    <form:select path="actuator">
                                        <form:option value="" label="*** Select Option ***" />
                                        <form:options items="${actuators}" itemValue="id" itemLabel="name" />
                                    </form:select>
                                </td>
                            </tr>
                            <tr>
                                <td>Místnost:</td>
                                <td>
                                    <form:select path="room">
                                        <form:option value="" label="*** Select Option ***" />
                                        <form:options items="${rooms}" itemValue="id" itemLabel="name" />
                                    </form:select>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2"><input type="submit" class="btn btn-success"
                                                       value="Vytvoř" /></td>
                            </tr>
                        </table>

                    </form:form>
                </div>

            </div>
        </div>


    </div>
</div>
</body>
</html>
