<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ include file="/WEB-INF/pages/parts/taglibs.jsp"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <%@ include file="/WEB-INF/pages/parts/styles.jsp"%>
    <spring:url value="/resources/styles/style.css" var="css_url" />

    <title>HomeAutomationWeb</title>
</head>
<body>
<div>
    <c:set var="contextPath" value="${pageContext.request.contextPath}"/>
    <%@ include file="/WEB-INF/pages/parts/header.jsp"%>
    <div class="container">
        <div class="row">
            <div id="main_content" class="col-md-12 col-centered">
                <div class="row text-center">
                    <h1>Setup</h1>
                </div>
                <hr />

                <div class="row">
                    <div class="col-md-1">
                        <h3>Uživatelé</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addUser/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Email</th><th>Jméno</th><th>Role</th><th></th></tr>
                    <c:forEach items="${setup.users}" var="user">
                        <tr>
                            <td>${user.email}</td>
                            <td>${user.name} ${user.surname}</td>
                            <td>${user.role}</td>
                            <td>
                                <%--<a class="btn btn-info" >Detail</a>--%>
                                <a class="btn btn-danger" href="${contextPath}/delete/user/${user.id}" >Smazat</a>
                            </td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />

                <div class="row">
                    <div class="col-md-1">
                        <h3>Zařízení</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addDevice/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Název</th><th>Typ</th><th>Mac Adresa</th><th>Uživatel</th><th>Stav</th><th></th></tr>
                    <c:forEach items="${setup.devices}" var="device">
                        <tr>
                            <td>${device.name}</td>
                            <td>${device.type}</td>
                            <td>${device.macAddress}</td>
                            <td>${device.user.name} ${device.user.surname}</td>
                            <td>${device.state}</td>
                            <td>
                                <%--<a class="btn btn-info" >Detail</a>--%>
                                <a class="btn btn-danger" href="${contextPath}/delete/device/${device.id}" >Smazat</a>
                            </td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />

                <div class="row">
                    <div class="col-md-1">
                        <h3>Místnosti</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addRoom/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Název</th><th>Typ</th><th></th></tr>
                    <c:forEach items="${setup.rooms}" var="room">
                        <tr>
                            <td>${room.name}</td>
                            <td>${room.type}</td>
                            <td>
                                <a class="btn btn-info" href="${contextPath}/pages/room/${room.id}" >Detail</a>
                            <a class="btn btn-danger" href="${contextPath}/delete/room/${room.id}" >Smazat</a></td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />
                <div class="row">
                    <div class="col-md-1">
                        <h3>Pravidla</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addRule/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Název</th><th>Podmínka</th><th>Příkaz</th><th>Komponenta</th><th>Místnost</th><th></th></tr>
                    <c:forEach items="${setup.rules}" var="rule">
                        <tr>
                            <td>${rule.name}</td>
                            <td>${rule.expression}</td>
                            <td>${rule.command}</td>
                            <td>${rule.actuator.name}</td>
                            <td>${rule.room.name}</td>
                            <td>
                                <%--<a class="btn btn-info" >Detail</a>--%>
                                <a class="btn btn-danger" href="${contextPath}/delete/rule/${rule.id}" >Smazat</a></td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />
                <div class="row">
                    <div class="col-md-1">
                        <h3>Sensory</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addSensor/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Id</th><th>Název</th><th>Umístění</th><th>Typ</th><th>Místnost</th><th></th></tr>
                    <c:forEach items="${setup.sensors}" var="sensor">
                        <tr>
                            <td>${sensor.id}</td>
                            <td>${sensor.name}</td>
                            <td>${sensor.location}</td>
                            <td>${sensor.type}</td>
                            <td>${sensor.room.name}</td>
                            <td>
                                <%--<a class="btn btn-info" >Detail</a>--%>
                                <a class="btn btn-danger" href="${contextPath}/delete/sensor/${sensor.id}" >Smazat</a></td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />
                <div class="row">
                    <div class="col-md-1">
                        <h3>Aktuátory</h3>
                    </div>
                    <div class="col-md-1 col-md-offset-1">
                        <a class="btn btn-info btn-add" href="${contextPath}/pages/addActuator/" >Přidat</a>
                    </div>
                </div>
                <table class="table table-striped">
                    <tr><th>Id</th><th>Název</th><th>Umístění</th><th>Typ</th><th>Místnost</th><th></th></tr>
                    <c:forEach items="${setup.actuators}" var="actuator">
                        <tr>
                            <td>${actuator.id}</td>
                            <td>${actuator.name}</td>
                            <td>${actuator.location}</td>
                            <td>${actuator.type}</td>
                            <td>${actuator.room.name}</td>
                            <td>
                                <%--<a class="btn btn-info" >Detail</a>--%>
                                <a class="btn btn-danger" href="${contextPath}/delete/actuator/${actuator.id}" >Smazat</a></td>
                        </tr>
                    </c:forEach>
                </table>
                <hr />


            </div>
        </div>
    </div>
</div>
</body>
</html>