<%@ page language="java" contentType="text/html; charset=UTF-8"
         pageEncoding="UTF-8"%>
<%@ include file="/WEB-INF/pages/parts/taglibs.jsp"%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <%@ include file="/WEB-INF/pages/parts/styles.jsp"%>
    <spring:url value="/resources/styles/style.css" var="css_url" />

    <title>HomeAutomationWeb</title>
</head>
<body>
<div>
    <c:set var="contextPath" value="${pageContext.request.contextPath}"/>
    <%@ include file="/WEB-INF/pages/parts/header.jsp"%>
    <div class="container">
        <div class="row">
            <div id="main_content" class="col-md-12 col-centered">
                <div class="row text-center">
                    <h1>${roomDO.room.name}</h1>
                </div>
                <hr />

                <table class="table table-striped text-center room_values">
                    <tr><td>Teplota:</td><td>${roomDO.temperature} °C</td></tr>
                    <tr><td>Vlhkost:</td><td>${roomDO.humidity} %</td></tr>
                    <tr>
                        <td>Světlo:</td>
                        <td>
                            <c:url var="lightOn" value="/call/lightOn/${roomDO.room.id}"/>
                            <c:url var="lightOff" value="/call/lightOff/${roomDO.room.id}"/>
                            <c:if test="${roomDO.lightState=='off'}">
                            <form action="${lightOn}">
                                Off: <input class="btn btn-info" type="submit" value="Zapnout" />
                            </form>
                            </c:if>
                            <c:if test="${roomDO.lightState=='on'}">
                            <form action="${lightOff}">
                                On: <input class="btn btn-info" type="submit" value="Vypnout" />
                                <%-- style="display: none;"--%>
                            </form>
                            </c:if>
                        </td>
                    </tr>
                </table>
                <hr />
                <sec:authorize access="hasAuthority('ADMIN')">
                    <div class="row">
                        <div class="col-md-1">
                            <h3>Pravidla</h3>
                        </div>
                        <div class="col-md-1 col-md-offset-1">
                            <a class="btn btn-info btn-add" href="${contextPath}/pages/addRule/">Přidat</a>
                        </div>
                    </div>
                    <table class="table table-striped">
                        <tr><th>Název</th><th>Podmínka</th><th>Příkaz</th><th>Komponenta</th><th></th></tr>
                        <c:forEach items="${rules}" var="rule">
                            <tr>
                                <td>${rule.name}</td>
                                <td>${rule.expression}</td>
                                <td>${rule.command}</td>
                                <td>${rule.actuator.name}</td>
                                <td>
                                    <%--<a class="btn btn-info" >Detail</a>--%>
                                    <a class="btn btn-danger" href="${contextPath}/delete/rule/${rule.id}" >Smazat</a>
                                </td>
                            </tr>
                        </c:forEach>
                    </table>
                    <hr />
                    <div class="row">
                        <div class="col-md-1">
                            <h3>Sensory</h3>
                        </div>
                        <div class="col-md-1 col-md-offset-1">
                            <a class="btn btn-info btn-add" href="${contextPath}/pages/addSensor/">Přidat</a>
                        </div>
                    </div>
                    <table class="table table-striped">
                        <tr><th>Id</th><th>Název</th><th>Umístění</th><th>Typ</th><th></th></tr>
                        <c:forEach items="${sensors}" var="sensor">
                            <tr>
                                <td>${sensor.id}</td>
                                <td>${sensor.name}</td>
                                <td>${sensor.location}</td>
                                <td>${sensor.type}</td>
                                <td>
                                    <%--<a class="btn btn-info" >Detail</a>--%>
                                        <a class="btn btn-danger" href="${contextPath}/delete/sensor/${sensor.id}" >Smazat</a>
                                </td>
                            </tr>
                        </c:forEach>
                    </table>
                    <hr />
                    <div class="row">
                        <div class="col-md-1">
                            <h3>Aktuátory</h3>
                        </div>
                        <div class="col-md-1 col-md-offset-1">
                            <a class="btn btn-info btn-add" href="${contextPath}/pages/addActuator/">Přidat</a>
                        </div>
                    </div>
                    <table class="table table-striped">
                        <tr><th>Id</th><th>Název</th><th>Umístění</th><th>Typ</th><th></th></tr>
                        <c:forEach items="${actuators}" var="actuator">
                            <tr>
                                <td>${actuator.id}</td>
                                <td>${actuator.name}</td>
                                <td>${actuator.location}</td>
                                <td>${actuator.type}</td>
                                <td>
                                    <%--<a class="btn btn-info" >Detail</a>--%>
                                    <a class="btn btn-danger" href="${contextPath}/delete/actuator/${actuator.id}" >Smazat</a>
                                </td>
                            </tr>
                        </c:forEach>
                    </table>
                    <hr />
                </sec:authorize>
            </div>
        </div>


    </div>
</div>
</body>
</html>